from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Int, Boolean

Seurat_Run_Pca_R_V0_1_0 = CommandToolBuilder(tool="seurat_run_pca.R", base_command=["seurat-run-pca.R"], inputs=[ToolInput(tag="in_input_object_file", input_type=File(optional=True), prefix="--input-object-file", doc=InputDocumentation(doc="File name in which a serialized R matrix object may be found.")), ToolInput(tag="in_input_format", input_type=String(optional=True), prefix="--input-format", doc=InputDocumentation(doc="Either loom, seurat, anndata or singlecellexperiment for the input format to read.")), ToolInput(tag="in_output_format", input_type=String(optional=True), prefix="--output-format", doc=InputDocumentation(doc="Either loom, seurat, anndata or singlecellexperiment for the output format.")), ToolInput(tag="in_pc_genes", input_type=File(optional=True), prefix="--pc-genes", doc=InputDocumentation(doc="File with gene names to scale/center. Default is all genes in object@data.")), ToolInput(tag="in_pc_cells", input_type=File(optional=True), prefix="--pc-cells", doc=InputDocumentation(doc="File with cell names to scale/center. Default is all cells in object@data.")), ToolInput(tag="in_pcs_compute", input_type=Int(optional=True), prefix="--pcs-compute", doc=InputDocumentation(doc="Total Number of PCs to compute and store (50 by default).")), ToolInput(tag="in_reverse_pc_a", input_type=Boolean(optional=True), prefix="--reverse-pca", doc=InputDocumentation(doc="By default computes the PCA on the cell x gene matrix. Setting to true will compute it on gene x cell matrix.")), ToolInput(tag="in_output_object_file", input_type=File(optional=True), prefix="--output-object-file", doc=InputDocumentation(doc="File name in which to store serialized R object of type 'Seurat'.'")), ToolInput(tag="in_output_embeddings_file", input_type=File(optional=True), prefix="--output-embeddings-file", doc=InputDocumentation(doc="File name in which to store a csv-format embeddings table with PCs by cell.")), ToolInput(tag="in_output_loadings_file", input_type=File(optional=True), prefix="--output-loadings-file", doc=InputDocumentation(doc="File name in which to store a csv-format loadings table with PCs by gene.")), ToolInput(tag="in_output_stdev_file", input_type=File(optional=True), prefix="--output-stdev-file", doc=InputDocumentation(doc="File name in which to store PC stdev values (one per line).")), ToolInput(tag="in_weight_by_var", input_type=Boolean(optional=True), prefix="--weight-by-var", doc=InputDocumentation(doc="Weight the cell embeddings by the variance of each PC (weights the gene loadings if rev.pca is TRUE)")), ToolInput(tag="in_ndims_print", input_type=Int(optional=True), prefix="--ndims-print", doc=InputDocumentation(doc="OF DIMS. PRINT\nPCs to print genes for")), ToolInput(tag="in_n_features_print", input_type=Int(optional=True), prefix="--nfeatures-print", doc=InputDocumentation(doc="FEATURES PRINT\nNumber of genes to print for each PC")), ToolInput(tag="in_reduction_key", input_type=Int(optional=True), prefix="--reduction-key", doc=InputDocumentation(doc="KEY\ndimensional reduction key, specifies the string before the number for the dimension names. PC by default")), ToolInput(tag="in_reduction_name", input_type=String(optional=True), prefix="--reduction-name", doc=InputDocumentation(doc="NAME\ndimensional reduction name, pca by default"))], outputs=[ToolOutput(tag="out_output_object_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_object_file", type_hint=File()), doc=OutputDocumentation(doc="File name in which to store serialized R object of type 'Seurat'.'")), ToolOutput(tag="out_output_embeddings_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_embeddings_file", type_hint=File()), doc=OutputDocumentation(doc="File name in which to store a csv-format embeddings table with PCs by cell.")), ToolOutput(tag="out_output_loadings_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_loadings_file", type_hint=File()), doc=OutputDocumentation(doc="File name in which to store a csv-format loadings table with PCs by gene.")), ToolOutput(tag="out_output_stdev_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_stdev_file", type_hint=File()), doc=OutputDocumentation(doc="File name in which to store PC stdev values (one per line)."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Seurat_Run_Pca_R_V0_1_0().translate("wdl", allow_empty_container=True)

